class LiveChatPlugin {
	constructor (API, name, config) {
		this.API = API;
		this.name = name;
		this.config = config;
	}

	addInsertions () {
		this.API.addInsertion('publiiFooter', this.addScript, 1, this);
	}

	addScript (rendererInstance, context) {
		let previewNotice = '';
		let scriptToLoad = '';
		let cookieBannerGroup = 'text/javascript';
		let licenseNumber = parseInt(this.config.licenseNumber, 10);

	    if (this.config.cookieBannerIntegration) {
			cookieBannerGroup = 'gdpr-blocker/' + this.config.cookieBannerGroup.trim();
		}

	    if (rendererInstance.previewMode && this.config.showPreviewNotice) {
	    	previewNotice = `<div style="background: #d33; border-radius: 5px; bottom: 20px; color: #fff; display: block; font-size: 12px; padding: 5px 10px; position: fixed; right: 20px; text-align: center; width: 120px; z-index: 1000001;">LiveChat does not work in preview mode.</div>`;
	    }

		if (!rendererInstance.previewMode) {
			scriptToLoad = `
			<script type="${cookieBannerGroup}">
				window.__lc = window.__lc || {};
				window.__lc.license = ${licenseNumber};
				;(function(n,t,c){function i(n){return e._h?e._h.apply(null,n):e._q.push(n)}var e={_q:[],_h:null,_v:"2.0",on:function(){i(["on",c.call(arguments)])},once:function(){i(["once",c.call(arguments)])},off:function(){i(["off",c.call(arguments)])},get:function(){if(!e._h)throw new Error("[LiveChatWidget] You can't use getters before load.");return i(["get",c.call(arguments)])},call:function(){i(["call",c.call(arguments)])},init:function(){var n=t.createElement("script");n.async=!0,n.type="text/javascript",n.src="https://cdn.livechatinc.com/tracking.js",t.head.appendChild(n)}};!n.__lc.asyncInit&&e.init(),n.LiveChatWidget=n.LiveChatWidget||e}(window,document,[].slice))
			</script>
			<noscript>${this.config.textFallback}</noscript>
			`;
		}

		return `
	        ${previewNotice}		
			${scriptToLoad}
    	`;
	}
}

module.exports = LiveChatPlugin;